(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["BasicStreams"] = factory();
	else
		root["BasicStreams"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var main = __webpack_require__(1);
	var fantasy = __webpack_require__(2);

	module.exports = _extends({}, main, { fantasy: fantasy });

/***/ },
/* 1 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.just = just;
	exports.map = map;
	exports.filter = filter;
	exports.chain = chain;
	exports.chainLatest = chainLatest;
	exports.ap = ap;
	exports.map2 = map2;
	exports.map3 = map3;
	exports.join = join;
	exports.scan = scan;
	exports.take = take;
	exports.takeWhile = takeWhile;
	exports.takeUntil = takeUntil;
	exports.skip = skip;
	exports.skipWhile = skipWhile;
	exports.skipDuplicates = skipDuplicates;
	exports.multicast = multicast;
	exports.transduce = transduce;

	// We're not sure yet if this function should be public
	function fromArray(xs) {
	  return function (sink) {
	    xs.forEach(function (x) {
	      sink(x);
	    });
	    return function () {};
	  };
	}

	/* Represents an empty stream
	 */

	// A helper to utilize Flow's Disjoint Unions
	// http://flowtype.org/blog/2015/07/03/Disjoint-Unions.html
	//
	var empty = exports.empty = function () {
	  return function () {};
	};

	/* Creates a stream containing given value
	 */
	function just(x) {
	  return function (sink) {
	    sink(x);
	    return function () {};
	  };
	}

	/* Lifts function `A => B` to a function that operates
	 * on streams `Stream<A> => Stream<B>`
	 */
	function map(fn) {
	  return function (stream) {
	    return function (sink) {
	      return stream(function (payload) {
	        return sink(fn(payload));
	      });
	    };
	  };
	}

	/* Given a predicate `A => boolean` returns a function
	 * that operates on streams `Stream<A> => Stream<A>`.
	 * The result function returns a stream without values that don't satisfy predicate.
	 */
	function filter(predicate) {
	  return function (stream) {
	    return function (sink) {
	      return stream(function (payload) {
	        if (predicate(payload)) {
	          sink(payload);
	        }
	      });
	    };
	  };
	}

	/* Given a function `A => Stream<B>` returns a function
	 * that operates on streams `Stream<A> => Stream<B>`.
	 * The result function will spawn a `Stream<B>`
	 * for each value from `Stream<A>` using the provided function.
	 * The final `Stream<B>` will contain values from all spawned streams.
	 */
	function chain(fn) {
	  return function (stream) {
	    return function (sink) {
	      var spawnedDisposers = [];
	      var mainDisposer = stream(function (payload) {
	        spawnedDisposers.push(fn(payload)(sink));
	      });
	      return function () {
	        spawnedDisposers.forEach(function (fn) {
	          return fn();
	        });
	        mainDisposer();
	      };
	    };
	  };
	}

	/* Same as `chain()`, except the final stream will contain
	 * only that values from each spawned streams that was
	 * emitted before the next stream was spawned.
	 */
	function chainLatest(fn) {
	  return function (stream) {
	    return function (sink) {
	      var spawnedDisposers = function () {};
	      var mainDisposer = stream(function (payload) {
	        spawnedDisposers();
	        spawnedDisposers = fn(payload)(sink);
	      });
	      return function () {
	        spawnedDisposers();
	        mainDisposer();
	      };
	    };
	  };
	}

	/* Given a stream of functions `Stream<A => B>`, returns a function
	 * that operates on streams `Stream<A> => Stream<B>`.
	 * The result stream `Stream<B>` will contain values created by applying
	 * the latest function from `Stream<A => B>` to the latest value from `Stream<A>`
	 * every time one of them updates.
	 */
	function ap(streamf) {
	  return function (streamv) {
	    return function (sink) {
	      var latestF = { type: 'nothing' };
	      var latestV = { type: 'nothing' };
	      var push = function () {
	        if (latestF.type === 'just' && latestV.type === 'just') {
	          var fn = latestF.value;
	          sink(fn(latestV.value));
	        }
	      };
	      var disposef = streamf(function (f) {
	        latestF = { type: 'just', value: f };
	        push();
	      });
	      var disposev = streamv(function (v) {
	        latestV = { type: 'just', value: v };
	        push();
	      });
	      return function () {
	        disposef();
	        disposev();
	      };
	    };
	  };
	}

	/* Lifts a 2 arity function `(A, B) => C` to a function that operates
	 * on streams `(Stream<A>, Stream<B>) => Stream<C>`
	 */
	function map2(fn) {
	  return function (sA, sB) {
	    var ofFn = map(function (a) {
	      return function (b) {
	        return fn(a, b);
	      };
	    })(sA);
	    return ap(ofFn)(sB);
	  };
	}

	/* Lifts a 3 arity function `(A, B, C) => D` to a function that operates
	 * on streams `(Stream<A>, Stream<B>, Stream<C>) => Stream<D>`
	 */
	function map3(fn) {
	  return function (sA, sB, sC) {
	    var ofFn = map(function (a) {
	      return function (b) {
	        return function (c) {
	          return fn(a, b, c);
	        };
	      };
	    })(sA);
	    return ap(ap(ofFn)(sB))(sC);
	  };
	}

	/* Merges several streams of same type to a single stream of that type.
	 * The result stream will contain values from all streams
	 *
	 * We should use name "merge" for this, but Flow behaves weirdly with that name https://github.com/facebook/flow/issues/1238
	 */
	function join(streams) {
	  return chain(function (x) {
	    return x;
	  })(fromArray(streams));
	}

	/* Given a reducer function `(B, A) => B`, and a seed value of type B,
	 * returns a function that operates on streams `Stream<A> => Stream<B>`.
	 * Will apply reducer to each value in `Stream<A>` and push the result to `Stream<B>`
	 */
	function scan(reducer, seed) {
	  return function (stream) {
	    return function (sink) {
	      var current = seed;
	      sink(current);
	      return stream(function (x) {
	        current = reducer(current, x);
	        sink(current);
	      });
	    };
	  };
	}

	/* Given a number N, returns a function that operates on streams `Stream<A> => Stream<A>`.
	 * The result stream will contain only first N items from source stream
	 */
	function take(n) {
	  return function (stream) {
	    return function (sink) {
	      var count = 0;
	      var disposer = null;
	      var dispose = function () {
	        if (disposer !== null) {
	          disposer();
	          disposer = null;
	        }
	      };
	      disposer = stream(function (x) {
	        count++;
	        if (count <= n) {
	          sink(x);
	        }
	        if (count >= n) {
	          dispose();
	        }
	      });
	      if (count >= n) {
	        dispose();
	      }
	      return dispose;
	    };
	  };
	}

	/* Given a predicate `A => boolean` returns a function
	 * that operates on streams `Stream<A> => Stream<A>`.
	 * The result stream will contain values from source stream
	 * before the first value that doesn't satisfy predicate.
	 */
	function takeWhile(pred) {
	  return function (stream) {
	    return function (sink) {
	      var completed = false;
	      var disposer = null;
	      var dispose = function () {
	        if (disposer !== null) {
	          disposer();
	          disposer = null;
	        }
	      };
	      disposer = stream(function (x) {
	        if (!completed) {
	          if (pred(x)) {
	            sink(x);
	          } else {
	            completed = true;
	            dispose();
	          }
	        }
	      });
	      if (completed) {
	        dispose();
	      }
	      return dispose;
	    };
	  };
	}

	/* Given a controller stream, returns a function that operates
	 * on streams `Stream<A> => Stream<A>`. The result stream will contain values
	 * from source stream until the first value from controller stream.
	 */
	function takeUntil(controller) {
	  return function (stream) {
	    return function (sink) {
	      var mainDisposer = null;
	      var ctrlDisposer = null;
	      var dispose = function () {
	        if (mainDisposer !== null) {
	          mainDisposer();
	          mainDisposer = null;
	        }
	        if (ctrlDisposer !== null) {
	          ctrlDisposer();
	          ctrlDisposer = null;
	        }
	      };

	      mainDisposer = stream(sink);
	      ctrlDisposer = controller(dispose);

	      // in case controller cb was called sync before we obtained ctrlDisposer
	      if (mainDisposer === null) {
	        dispose();
	      }

	      return dispose;
	    };
	  };
	}

	/* Given a number N, returns a function that operates on streams `Stream<A> => Stream<A>`.
	 * The result stream will contain only items from source starting from (N+1)th one
	 */
	function skip(n) {
	  return function (stream) {
	    return function (sink) {
	      var count = 0;
	      return stream(function (x) {
	        count++;
	        if (count > n) {
	          sink(x);
	        }
	      });
	    };
	  };
	}

	/* Given a predicate `A => boolean` returns a function
	 * that operates on streams `Stream<A> => Stream<A>`.
	 * The result stream will contain values from source stream
	 * starting from the first that doesn't satisfy predicate.
	 */
	function skipWhile(pred) {
	  return function (stream) {
	    return function (sink) {
	      var started = false;
	      return stream(function (x) {
	        if (!started) {
	          started = !pred(x);
	        }
	        if (started) {
	          sink(x);
	        }
	      });
	    };
	  };
	}

	/* Given a comparator function `(A, A) => boolean` returns a function that
	 * operates on streams `Stream<A> => Stream<A>`. For each element X from
	 * the source stream (except the first one) calls comparator with (Y, X)
	 * as arguments, where Y is the last element in the result stream.
	 * If comparator returns false, X goes to the result stream.
	 */
	function skipDuplicates(comp) {
	  return function (stream) {
	    return function (sink) {
	      var latest = { type: 'nothing' };
	      return stream(function (x) {
	        if (latest.type === 'nothing' || !comp(latest.value, x)) {
	          latest = { type: 'just', value: x };
	          sink(x);
	        }
	      });
	    };
	  };
	}

	/* Given a stream returns a new stream of same type. The new stream will
	 * have at most one subscription at any given time to the original stream.
	 * It allows you to connect several subscribers to a stream using only one subscription.
	 */
	function multicast(stream) {
	  var sinks = [];
	  var push = function (x) {
	    sinks.forEach(function (sink) {
	      if (sinks.indexOf(sink) !== -1) {
	        sink(x);
	      }
	    });
	  };
	  var unsub = null;
	  return function (sink) {
	    var disposed = false;
	    sinks = [].concat(sinks, [sink]);
	    if (sinks.length === 1) {
	      unsub = stream(push);
	    }
	    return function () {
	      if (disposed) {
	        return;
	      }
	      disposed = true;
	      var index = sinks.indexOf(sink);
	      sinks = [].concat(sinks.slice(0, index), sinks.slice(index + 1, sinks.length));
	      if (sinks.length === 0 && unsub !== null) {
	        unsub();
	        unsub = null;
	      }
	    };
	  };
	}

	/* Given a transducer that conforms [Protocol][1],
	 * returns a function that operates on streams `Stream<A> => Stream<B>`.
	 *
	 * [1]: https://github.com/cognitect-labs/transducers-js#the-transducer-protocol
	 */
	function transduce(transducer) {
	  return function (stream) {
	    return function (sink) {
	      var thisDisposed = false;
	      var sourceDisposer = null;

	      var transformer = transducer({
	        '@@transducer/result': function () {},
	        '@@transducer/step': function (result, input) {
	          if (!thisDisposed) {
	            sink(input);
	          }
	          return result;
	        }
	      });

	      var disposeSource = function () {
	        if (sourceDisposer !== null) {
	          sourceDisposer();
	          sourceDisposer = null;
	        }
	      };

	      sourceDisposer = stream(function (x) {
	        if (transformer === null) {
	          return;
	        }

	        // it returns either null or tReduced<null>
	        if (null !== transformer['@@transducer/step'](null, x)) {
	          transformer['@@transducer/result'](null);
	          transformer = null;
	          disposeSource();
	        }
	      });

	      if (transformer === null) {
	        disposeSource();
	      }

	      return function () {
	        thisDisposed = true;
	        disposeSource();
	      };
	    };
	  };
	}

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.Stream = undefined;

	var _index = __webpack_require__(1);

	var bs = _interopRequireWildcard(_index);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var Stream = exports.Stream = function () {

	  // Example:
	  //
	  //    const myWrappedStream = new Stream(sink => {
	  //      sink(1)
	  //      retrun () => {}
	  //    })
	  //

	  function Stream(basicStream) {
	    _classCallCheck(this, Stream);

	    // The wrapped BasicStream is available as `wrapped.observe`.
	    // You can call it as a method in order to subscribe to the stream:
	    //
	    //    const usub = wrapped.observe(callback)
	    //    unsub()
	    //
	    // Or you can use `wrapped.observe` to extract BasicStream from the wrapper e.g.:
	    //
	    //    const basicStream2 = map(x => x * 2)(wrapped.observe)
	    //
	    this.observe = basicStream;
	  }

	  // Semigroup

	  Stream.prototype.concat = function concat(other) {
	    return new Stream(bs.join([this.observe, other.observe]));
	  };

	  // Monoid

	  Stream.empty = function empty() {
	    return new Stream(bs.empty);
	  };

	  Stream.prototype.empty = function empty() {
	    return Stream.empty();
	  };

	  // Functor

	  Stream.prototype.map = function map(f) {
	    return new Stream(bs.map(f)(this.observe));
	  };

	  // Apply

	  Stream.prototype.ap = function ap(other) {
	    // In order for .ap() to work `this` must be a `Stream<A => B>`,

	    var streamF = this.observe;
	    return new Stream(bs.ap(streamF)(other.observe));
	  };

	  // Applicative

	  Stream.of = function of(x) {
	    return new Stream(bs.just(x));
	  };

	  Stream.prototype.of = function of(x) {
	    return Stream.of(x);
	  };

	  // Chain

	  Stream.prototype.chain = function chain(f) {
	    return new Stream(bs.chain(function (x) {
	      return f(x).observe;
	    })(this.observe));
	  };

	  // ------------------ Not from FL ------------------

	  Stream.prototype.filter = function filter(f) {
	    return new Stream(bs.filter(f)(this.observe));
	  };

	  Stream.prototype.scan = function scan(f, seed) {
	    return new Stream(bs.scan(f, seed)(this.observe));
	  };

	  Stream.prototype.chainLatest = function chainLatest(f) {
	    return new Stream(bs.chainLatest(function (x) {
	      return f(x).observe;
	    })(this.observe));
	  };

	  Stream.prototype.take = function take(n) {
	    return new Stream(bs.take(n)(this.observe));
	  };

	  Stream.prototype.takeWhile = function takeWhile(f) {
	    return new Stream(bs.takeWhile(f)(this.observe));
	  };

	  Stream.prototype.takeUntil = function takeUntil(other) {
	    return new Stream(bs.takeUntil(other.observe)(this.observe));
	  };

	  Stream.prototype.skip = function skip(n) {
	    return new Stream(bs.skip(n)(this.observe));
	  };

	  Stream.prototype.skipWhile = function skipWhile(f) {
	    return new Stream(bs.skipWhile(f)(this.observe));
	  };

	  Stream.prototype.skipDuplicates = function skipDuplicates(f) {
	    return new Stream(bs.skipDuplicates(f)(this.observe));
	  };

	  Stream.prototype.multicast = function multicast() {
	    return new Stream(bs.multicast(this.observe));
	  };

	  Stream.prototype.transduce = function transduce(transducer) {
	    return new Stream(bs.transduce(transducer)(this.observe));
	  };

	  Stream.join = function join(streams) {
	    return new Stream(bs.join(streams.map(function (x) {
	      return x.observe;
	    })));
	  };

	  Stream.map2 = function map2(f) {
	    var lifted = bs.map2(f);
	    return function (sA, sB) {
	      return new Stream(lifted(sA.observe, sB.observe));
	    };
	  };

	  Stream.map3 = function map3(f) {
	    var lifted = bs.map3(f);
	    return function (sA, sB, sC) {
	      return new Stream(lifted(sA.observe, sB.observe, sC.observe));
	    };
	  };

	  return Stream;
	}();

/***/ }
/******/ ])
});
;